/**
 * \file
 *
 * \brief SAM E54 HRI top-level header file
 *
 * Copyright (C) 2016 Atmel Corporation. All rights reserved.
 *
 * \asf_license_start
 *
 * \page License
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. The name of Atmel may not be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. This software may only be redistributed and used in connection with an
 *    Atmel microcontroller product.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * \asf_license_stop
 */

#ifndef _HRI_E54_H_INCLUDED_
#define _HRI_E54_H_INCLUDED_

#include <sam.h>
#include <hri_ac_e54.h>
#include <hri_adc_e54.h>
#include <hri_aes_e54.h>
#include <hri_can_e54.h>
#include <hri_ccl_e54.h>
#include <hri_cmcc_e54.h>
#include <hri_dac_e54.h>
#include <hri_dmac_e54.h>
#include <hri_dsu_e54.h>
#include <hri_eic_e54.h>
#include <hri_evsys_e54.h>
#include <hri_freqm_e54.h>
#include <hri_gclk_e54.h>
#include <hri_gmac_e54.h>
#include <hri_hmatrixb_e54.h>
#include <hri_i2s_e54.h>
#include <hri_icm_e54.h>
#include <hri_mclk_e54.h>
#include <hri_mpu_e54.h>
#include <hri_nvic_e54.h>
#include <hri_nvmctrl_e54.h>
#include <hri_osc32kctrl_e54.h>
#include <hri_oscctrl_e54.h>
#include <hri_pac_e54.h>
#include <hri_pcc_e54.h>
#include <hri_pdec_e54.h>
#include <hri_pm_e54.h>
#include <hri_port_e54.h>
#include <hri_qspi_e54.h>
#include <hri_ramecc_e54.h>
#include <hri_rstc_e54.h>
#include <hri_rtc_e54.h>
#include <hri_sdhc_e54.h>
#include <hri_sercom_e54.h>
#include <hri_supc_e54.h>
#include <hri_systemcontrol_e54.h>
#include <hri_systick_e54.h>
#include <hri_tc_e54.h>
#include <hri_tcc_e54.h>
#include <hri_trng_e54.h>
#include <hri_usb_e54.h>
#include <hri_wdt_e54.h>

#endif /* _HRI_E54_H_INCLUDED_ */
